//
//  SRDownloadModel.h
//  SRDownloadManager
//
//  Created by https://github.com/guowilling on 17/1/10.
//  Copyright © 2017年 SR. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

typedef NS_ENUM(NSInteger, SRDownloadState) {
    SRDownloadStateWaiting,
    SRDownloadStateRunning,
    SRDownloadStateSuspended,
    SRDownloadStateCanceled,
    SRDownloadStateCompleted,
    SRDownloadStateFailed
};

typedef void (^SRStateBlock)(SRDownloadState state);

typedef void (^SRProgressBlock)(NSInteger receivedSize, NSInteger expectedSize, CGFloat progress);

typedef void (^SRCompletionBlock)(BOOL success, NSString *filePath, NSError *error);

@interface SRDownloadModel : NSObject

@property (nonatomic, strong) NSOutputStream *outputStream;

@property (nonatomic, strong) NSURLSessionDataTask *dataTask;

@property (nonatomic, strong) NSURL *URL;

@property (nonatomic, assign) NSInteger totalLength;

@property (nonatomic, copy) NSString *destPath;

@property (nonatomic, copy) SRStateBlock state;

@property (nonatomic, copy) SRProgressBlock progress;

@property (nonatomic, copy) SRCompletionBlock completion;

- (void)openOutputStream;

- (void)closeOutputStream;

@end
